package Utils::Array;
use Carp;
use warnings;
use strict;

###################################################
sub unique {
    my $array = shift or croak "An array is not defined.";
    my $hash = {};
    foreach my $entry (@$array){
	$hash->{$entry} = 1;
    }
    my @uniqueEntries = sort keys %$hash;
    return \@uniqueEntries;
}

###################################################
sub ave {
    my @vals = @_;
    my $sum = 0.0;
    foreach my $val (@vals){
	$sum += $val;
    }
    return $sum / scalar(@vals);
}

###################################################
sub var {
    my @vals = @_;
    my $ave = ave(@vals);
    my $sum = 0.0;
    foreach my $val (@vals){
	$sum += ($val - $ave) * ($val - $ave);
    }
    return $sum / scalar(@vals);
}

###################################################
sub SD {
    my @vals = @_;
    return sqrt( var(@vals) );
}

###################################################
sub max {
    my @vals = @_;
    my $maxVal = $vals[0];
    for( my $i=1 ; $i<@vals ; ++$i ){
	$maxVal = $vals[$i] if $vals[$i] > $maxVal;
    }
    return $maxVal;
}

###################################################
sub min {
    my @vals = @_;
    my $minVal = $vals[0];
    for( my $i=1 ; $i<@vals ; ++$i ){
	$minVal = $vals[$i] if $vals[$i] < $minVal;
    }
    return $minVal;
}

1;
